function ALERT(app) {

    var _ = require('lodash');
    var moment = require('moment');
    var self = this;
    self.format = function (input) {
        var finalData = [];
        var alerts = []
        if (input.constructor===Array) alerts = input;
        else alerts.push(input);
        _.map(alerts, function (alert) {
            try {
                var item = {
                    "id": alert.uuid + "_" + alert.reported_on,
                    "uuid": alert.uuid, "event": alert.event, "type": alert.type, "severity": alert.severity,
                    "reported_on": moment.unix(alert.reported_on), "short_message": alert.short_message,
                    "data": JSON.parse(alert.data), "created_date": moment(), "updated_date": moment()
                };

                if (item.data.bee_state) {
                    if (item.data.bee_state.last_msg) {
                        if (item.data.bee_state.last_msg.msg) {
                            item.HUM = item.data.bee_state.last_msg.msg.HUM ? item.data.bee_state.last_msg.msg.HUM.measured_value ? parseFloat(item.data.bee_state.last_msg.msg.HUM.measured_value) : 0 : 0;
                            item.PRS = item.data.bee_state.last_msg.msg.PRS ? item.data.bee_state.last_msg.msg.PRS.measured_value ? parseFloat(item.data.bee_state.last_msg.msg.PRS.measured_value) : 0 : 0;
                            item.TMP = item.data.bee_state.last_msg.msg.TMP ? item.data.bee_state.last_msg.msg.TMP.measured_value ? parseFloat(item.data.bee_state.last_msg.msg.TMP.measured_value) : 0 : 0;
                            item.ALT = item.data.bee_state.last_msg.msg.ALT ? item.data.bee_state.last_msg.msg.ALT.measured_value ? parseFloat(item.data.bee_state.last_msg.msg.ALT.measured_value) : 0 : 0;
                            item.TLT = item.data.bee_state.last_msg.msg.TLT ? item.data.bee_state.last_msg.msg.TLT.measured_value ? parseFloat(item.data.bee_state.last_msg.msg.TLT.measured_value) : 0 : 0;
                            item.DIS = item.data.bee_state.last_msg.msg.DIS ? item.data.bee_state.last_msg.msg.DIS.measured_value ? parseFloat(item.data.bee_state.last_msg.msg.DIS.measured_value) : 0 : 0;
                            item.AMB = item.data.bee_state.last_msg.msg.AMB ? item.data.bee_state.last_msg.msg.AMB.measured_value ? parseInt(item.data.bee_state.last_msg.msg.AMB.measured_value) : 0 : 0;
                            item.SHOCK = item.data.bee_state.last_msg.msg.SHOCK ? item.data.bee_state.last_msg.msg.SHK.shock_code ? parseInt(item.data.bee_state.last_msg.msg.SHK.shock_code) : 0 : 0;
                            item.BLE = item.data.bee_state.last_msg.msg.BLE ? item.data.bee_state.last_msg.msg.BLE.enabled ? parseInt(item.data.bee_state.last_msg.msg.BLE.enabled) : 0 : 0;
                            item.reported_accuracy = item.data.bee_state.last_msg.msg.geo ? item.data.bee_state.last_msg.msg.geo.reported_accuracy ? parseInt(item.data.bee_state.last_msg.msg.geo.reported_accuracy) : 0 : 0;
                            item.MAJOR = item.data.bee_state.last_msg.msg.MAJOR ? item.data.bee_state.last_msg.msg.MAJOR : "";
                            item.MINOR = item.data.bee_state.last_msg.msg.MINOR ? item.data.bee_state.last_msg.msg.MINOR : "";
                            item.battery = item.data.bee_state.last_msg.msg.battery ? parseInt(item.data.bee_state.last_msg.msg.battery) : 0;
                            if (item.data.bee_state.last_msg.msg.geo) {
                                item.GPS = { "lat": parseFloat(item.data.bee_state.last_msg.msg.geo.lat), "lon": parseFloat(item.data.bee_state.last_msg.msg.geo.lng) }
                            } else {
                                item.GPS = { "lat": 0, "lon": 0 }
                            }
                        }
                    }
                }
                item.data = JSON.stringify(item.data);
                finalData.push(item);
            } catch (err) {
                if (err) app.log.error("RB_ES: ES_FORMATTER_ERROR ALERT_INDEX", err,alert);
            }
        })
        return finalData;
    }

}

module.exports = ALERT;