function parseIntoJson (value){
    if(typeof value == 'object' && value != null)
        return value
    var parsedValue;
    try{
        parsedValue = JSON.parse(value)
    }catch(e){
        parsedValue = {}
    }
    if(!parsedValue){
        parsedValue = {}
    }
    return parsedValue
}

function ASSET(app) {
    var _ = require('lodash');
    var moment = require('moment');
    var self = this;
    self.format = function (input,fromES) {
        var finalData = []
        var assets = []
        if (input.constructor===Array) assets = input;
        else assets.push(input);
        assets.map(function(asset){
            try{
                var asset_id = asset.id
                var search_filters_array = []
                var data = parseIntoJson(asset.json_data)
                var cstm_fields = data['custom_fields'] || {}
                var categories = data['categories'] || []
                var labels = data['labels'] || []
                var targetString;
                var categories_map = {}
                for (var key in cstm_fields){
                    var values = cstm_fields[key]
                    if(values && values.length > 0){
                        values.map(function(_val){
                            //ignore in case value is null
                            if(_val == null){
                                return
                            }
                            if(typeof _val == 'object'){
                                if(_val && _val.length > 0){
                                    _val = _val[0]
                                }
                            }
                            targetString = key.toLowerCase() +'.'+ _val.toLowerCase()
                            search_filters_array.push(targetString)
                        })
                    } 
                }

                if(labels && labels.length >0){
                    labels.map(function(label){
                        if(label == null){
                                return
                        }
                        targetString = 'labels' +'.'+ label.toLowerCase()
                        search_filters_array.push(targetString)
                    })
                    cstm_fields['labels'] = labels
                }
                
                var cstm_fieldsV1 = {}
                for (var key in cstm_fields){
                    var value = cstm_fields[key]
                    var valueV1 = []
                    value.map(function(_val){
                        //ignore in case value is null
                        if(_val == null){
                                return
                        }
                        if(typeof _val == 'object'){
                                if(_val && _val.length > 0){
                                    _val = _val[0]
                                }
                        }
                        _val = _val.toLowerCase()
                        valueV1.push(_val)
                    })
                    cstm_fieldsV1[key.toLowerCase()] = valueV1
                }

                var zonePathJson = asset.zone_path
                try{
                    zonePathJson = JSON.parse(zonePathJson)
                }catch(e){
                    zonePathJson = []
                }

                if(!zonePathJson){
                    zonePathJson = []
                }

                var zone_path = []
                zonePathJson.map(function(value){
                    if(value && value.length>2){
                        zone_path.push(value[2])
                    }
                })

                //put all the values in lowercase syntax
                if(categories && categories.length){
                    categories.map(function(_category){
                        let __val = []
                        if(_category['values'] && _category['values'].length && _category['values'].length > 0){
                            _category['values'].map(function(_val){
                                if(_val){
                                    __val.push(_val.toLowerCase())
                                }
                            })
                        }
                        categories_map[_category['name']] = __val
                    })
                }
                var __shipment_name;
                if (asset.shipment_data) {
                    asset.shipment_data = JSON.parse(asset.shipment_data);
                    __shipment_name = asset.shipment_data.name;
                }

                var geoJson = {}
                if(asset.last_known_meta){
                    geoJson = JSON.parse(asset.last_known_meta)
                }
                if(!geoJson){
                    geoJson = {}
                }

                //if current content is shipment and shipment uuid is not present then it is clearly not on a shipment
                if(asset.current_context == 'shipment' && !asset.shipment_uuid){
                    asset.current_context = "asset"
                }
                
                var last_known_time = parseInt(geoJson.last_known_time)
                if(!last_known_time){
                    last_known_time = moment().unix()
                }
                var doc = {
                    id:asset.id,
                    uuid: asset.uuid,
                    client_asset_number: asset.client_asset_number,
                    description: asset.description,
                    active_status: asset.active_status,
                    client_contract_id: asset.client_contract_id,
                    device_imei: asset.device_imei,
                    account_id: asset.account_id,
                    asset_type: asset.asset_type,
                    last_known_meta:asset.last_known_meta,
                    name : asset.name,
                    current_context : asset.current_context,
                    zone_id : asset.zone_id,
                    //custom_fields : cstm_fields,
                    custom_fields : cstm_fieldsV1,
                    categories:categories_map,
                    shipment_uuid:asset.shipment_uuid,
                    shipment_name: __shipment_name || '',
                    filters:search_filters_array,
                    state:asset.state,
                    zone_path:zone_path,
                    bee_name:asset.bee_name,
                    account_name:asset.account_name,
                    created_date:asset.created_date,
                    zone_lat_lng : JSON.stringify(data['zone_lat_lng']),
                    beezone_label : asset.beezone_label ? asset.beezone_label.toLowerCase() : undefined,
                    last_known_time: last_known_time
                };
                finalData.push(doc);
            }
            catch(e){
                app.log.error("RB_ES: ES_FORMATTER_ERROR ASSET_INDEX", e,asset);
            }
        })
        return finalData;
    }
}
module.exports=ASSET;