function BEE(app) {


    var _ = require('lodash');
    var moment = require('moment');
    var ObjectFactory = require('rb-of');
    var self = this;
    self.format = function (input, fromES, isInsert) {
        var finalData = []
        var bees = []
        if (input.constructor === Array) bees = input;
        else bees.push(input);
        _.map(bees, function (beee, i) {
            try {
                var bee = {}
                if (beee.attributes) {
                    bee = _.merge(bee, beee.attributes);
                    bee = _.merge(bee, beee);
                    bee.shipment = [];
                    if (beee.relations.shipments.toArray().length > 0) bee.shipment.push(_.merge({}, beee.relations.shipments.toArray()[0].attributes));
                    bee.account = _.merge({}, beee.relations.account.attributes);
                } else {
                    bee = beee;
                }
                var state = checkNested(bee, ['state'], isInsert == false ? {} : null);
                state = state != null ? typeof state == 'string' ? JSON.parse(state) : state : state;
                var monitor_state = checkNested(bee, ['monitor_state'], isInsert == false ? {} : null);
                monitor_state = monitor_state != null ? typeof monitor_state == 'string' ? JSON.parse(monitor_state) : monitor_state : monitor_state;
                var last_msg = checkNested(state, ['last_msg'], isInsert == false ? {} : null);
                last_msg = last_msg != null ? typeof last_msg == 'string' ? JSON.parse(last_msg) : last_msg : last_msg;
                var data = checkNested(bee, ['data'], isInsert == false ? {} : null);
                data = data != null ? JSON.stringify(data) : data;
                var path = checkNested(bee, ['account', 'path']);
                path = path != null ? path.split('.') : null;

                var comm = null;
                if (checkNested(monitor_state, ['last_battery_alert']) && checkNested(state, ['last_msg', 'msg', 'created_date'])) {
                    if ((state.last_msg.msg.created_date / 1000) > moment().subtract(4 * 60, 'minutes').unix()) {
                        comm = 'OK';
                    } else if (monitor_state.last_battery_alert === "DRAINED") comm = "NOCOMM"
                    else comm = "NONTWK"
                }
                if (state != null) state.created_date = checkNested(state, ['created_date']) != null ? state.created_date.toString().length == 10 ? state.created_date * 1000 : state.created_date : null;
                var document = {
                    'uuid': bee.uuid,
                    'account_id': checkNested(bee, ['account', 'id']),
                    'account_name': checkNested(bee, ['account', 'name']),
                    'bee_number': checkNested(bee, ['bee_number']),
                    'bee_name': checkNested(bee, ['bee_name']),
                    'imei': checkNested(bee, ['imei']),
                    'device_type': checkNested(bee, ['device_type'], isInsert == false ? 'unknown' : null),
                    'mobile_number': checkNested(bee, ['mobile_number']),
                    'sim_number': checkNested(bee, ['sim_number']),
                    'carrier': checkNested(bee, ['carrier']),
                    'password': checkNested(bee, ['password']),
                    'active': checkNested(bee, ['active']) != null ? bee.active == 1 ? true : false : null,
                    'created_date': checkNested(bee, ['created_date']),
                    'bee_version': checkNested(last_msg, ['msg', 'created_date']),
                    'communication': comm,
                    'temp': checkNested(state, ['temperature', 'temp']) != null ? parseFloat(state.temperature.temp) : null,
                    'light_state': checkNested(last_msg, ['msg', 'sensor', 'light_state']),
                    'pressure': checkNested(last_msg, ['msg', 'PRS', 'measured_value']) != null ? parseFloat(last_msg.msg.PRS.measured_value) : null,
                    'humidity': checkNested(last_msg, ['msg', 'HUM', 'measured_value']) != null ? parseFloat(last_msg.msg.HUM.measured_value) : null,
                    'ambient': checkNested(last_msg, ['msg', 'AMB', 'measured_value']) != null ? parseFloat(last_msg.msg.AMB.measured_value) : null,
                    'tiltshock': checkNested(last_msg, ['msg', 'TLT', 'measured_value']) != null ? parseFloat(last_msg.msg.TLT.measured_value) : null,
                    'altitude': checkNested(last_msg, ['msg', 'ALT', 'measured_value']) != null ? parseFloat(last_msg.msg.ALT.measured_value) : null,
                    'tamper': checkNested(monitor_state, ['last_tamper_alert']),
                    'shock': checkNested(last_msg, ['msg', 'SHK', 'shock_code']) != null ? parseFloat(last_msg.msg.SHK.shock_code) : null,
                    'last_known_time': checkNested(state, ['created_date']) != null ? moment(state.created_date).format("MMM DD YYYY hh:mm a") : null,
                    'last_message_time': checkNested(state, ['created_date']) != null ? moment(state.created_date).format("MMM DD YYYY hh:mm a") : null,
                    'last_message_timestamp': checkNested(state, ['created_date']),
                    'last_known_timestamp': checkNested(state, ['created_date']),
                    'ping_frequency': prfMaker(bee),
                    'hub_name': checkNested(bee, ['hub_name']),
                    'last_message_server': checkNested(last_msg, ['msg', 'listener_hostname']),
                    'last_message_protocol': checkNested(last_msg, ['msg', 'protocol']),
                    'last_known_location': checkNested(last_msg, ['msg', 'geo', 'address']),
                    'device_version': checkNested(last_msg, ['msg', 'DEV', 'version']),
                    'firmware_rev': checkNested(last_msg, ['msg', 'DEV', 'model_number']),
                    'battery_type': checkNested(bee, ['battery_type']),
                    'account': checkNested(bee, ['account']),
                    'shipment_name': checkNested(bee, ['shipment']) != null ? bee.shipment.length > 0 ? bee.shipment[0].data.name : null : null,
                    'shipment_uuid': checkNested(bee, ['shipment']) != null ? bee.shipment.length > 0 ? bee.shipment[0].uuid : null : null,
                    'shipments': checkNested(bee, ['shipment']),
                    'beezone_uuid': checkNested(bee, ['beezone_uuid']),
                    'beezone_label': checkNested(bee, ['beezone_label']),
                    'asset_uuid': checkNested(bee, ['asset_uuid']),
                    'asset_name': checkNested(bee, ['asset_name']),
                    'dev_src': checkNested(bee, ['dev_src']),
                    'data': data,
                    'path': path,
                    'recent_pings': checkNested(bee, ['recent_pings']),
                    'VIN_number': checkNested(state, ['last_msg', 'msg', 'obd', 'VIN']),
                    'last_known_geo': checkNested(state, ['geo']) != null ? {
                        lat: state.geo.lat,
                        lon: state.geo.lng
                    } : null,
                    "battery_remaining_days": checkNested(state, ['battery_remaining_days']),
                    "ping_count": checkNested(state, ['ping_count']),
                    "battery_state": checkNested(state, ['battery_state']),
                    "battery_remaining_percentage": checkNested(state, ['battery_remaining_percentage']),
                    'monitor_state': monitor_state != null ? JSON.stringify(monitor_state) : null,
                    'state': state != null ? JSON.stringify(state) : null,
                    'last_msg': last_msg != null ? JSON.stringify(last_msg) : null,
                    'zone_last_seen_ts': checkNested(bee, ['zone_last_seen_ts'])
                };
                document.account = document.account != null ? typeof document.account === "object" ? JSON.stringify(document.account) : document.account : null;
                document.shipments = document.shipments != null ? typeof document.shipments === "object" ? JSON.stringify(document.shipments) : document.shipments : null;
                deleteIfNull(document);
                document.isInsert = bee.isInsert
                finalData.push(document);
            } catch (err) {
                if (err) app.log.error("RB_ES: ES_FORMATTER_ERROR BEE_INDEX", err, bee);

            }
        })
        return finalData
    }
}
function checkNested(obj, keys, defaultValue /*, level1, level2, ... levelN*/) {
    var args = keys //    Array.prototype.slice.call(arguments, 1);
    defaultValue = defaultValue ? defaultValue : null
    for (var i = 0; i < args.length; i++) {
        if (!obj || !obj.hasOwnProperty(args[i])) {
            return defaultValue;
        }
        obj = obj[args[i]];
        if (i == args.length - 1)
            return obj;
    }

}
//// delete key from object if key is null
function deleteIfNull(obj) {
    for (var prop in obj) {
        if (obj[prop] == null) delete obj[prop];
    }
}
function prfMaker(bee) {
    let prf = null;
    if(bee.ping_frequency===undefined){prf=null;}
    else if (bee.ping_frequency < 60) prf = 60 * 60;
    else if (bee.ping_frequency == null) {
        
        if (bee.asset_uuid) prf = 60 * 60 * 24;
        else prf = 60 * 60 * 4;
    } else {
        
        prf = bee.ping_frequency;
    }
    return prf;
}
module.exports = BEE;